//------------------------------------------------------------------
#property copyright "dr.house7 & mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LightGray  
#property indicator_color2  DarkGray
#property indicator_color3  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_level1  0

//
//
//
//
//

extern int    RsiPeriod1   = 14;
extern double Speed1       = 1.2;
extern int    RsiPrice1    = PRICE_CLOSE;
extern int    RsiPeriod2   = 34;
extern double Speed2       = 0.8;
extern int    RsiPrice2    = PRICE_CLOSE;
extern int    SignalPeriod = 9;
extern int    SignalMethod = MODE_SMA;

double macdh[];
double macd[];
double signal[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,macdh); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macd); 
   SetIndexBuffer(2,signal); 
      IndicatorShortName("ma rsi adaptive MACD("+RsiPeriod1+","+DoubleToStr(Speed1,2)+","+RsiPeriod2+","+DoubleToStr(Speed2,2)+")");
   return(0);
}
int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) 
   {
      macd[i]  = iMaRsi(RsiPrice1,RsiPeriod1,Speed1,i,0)-iMaRsi(RsiPrice2,RsiPeriod2,Speed2,i,1);
      macdh[i] = macd[i];
   }      
   for(i=limit; i>=0; i--) signal[i] = iMAOnArray(macd,0,SignalPeriod,0,SignalMethod,i);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workMaRsi[][2];
double iMaRsi(int price, int rsiPeriod, double speed, int i, int instanceNo=0)
{
   if (ArrayRange(workMaRsi,0)!=Bars) ArrayResize(workMaRsi,Bars); int r = Bars-i-1;

   //
   //
   //
   //
   //
   
   double tprice = iMA(NULL,0,1,0,MODE_SMA,price,i);
      if (r<rsiPeriod)
            workMaRsi[r][instanceNo] = tprice;
      else  workMaRsi[r][instanceNo] = workMaRsi[r-1][instanceNo]+(speed*MathAbs(iRSI(NULL,0,rsiPeriod,price,i)/100.0-0.5))*(tprice-workMaRsi[r-1][instanceNo]);
   return(workMaRsi[r][instanceNo]);
}